clear all
% u''(x)=u(x)+x
% u(0)=0
% u(1)=0
% elementi finiti
exact = @(x) (exp(x)-exp(-x))/(exp(1)-exp(-1))-x;
a = 0;
b = 1;
mrange = 50:10:100;
counter = 0;
for m = mrange
  counter = counter+1;
  x = linspace(a,b,m)';
% posso perturbare i nodi interni per vedere che funziona lo stesso
  x(2:m-1) = x(2:m-1)+(b-a)/m*(rand(m-2,1)-0.5)/5;
  h = diff(x);
% stiffness matrix
  A = spdiags([[-1./h(1:m-1);0],...
	       [1/h(1);1./h(1:m-2)+1./h(2:m-1);1/h(m-1)],...
	       [0;-1./h(1:m-1)]],[-1:1],m,m);
% mass matrix
  B = spdiags([[h(1:m-1)/6;0],...
	       [h(1)/3;h(1:m-2)/3+h(2:m-1)/3;h(m-1)/3],...
	       [0;h(1:m-1)/6]],[-1:1],m,m);
  M = -A-B;
% Dirichlet boundary conditions
  M(1,1) = 1/h(1);
  M(1,2) = 0;
  M(m,m-1) = 0;
  M(m,m) = 1/h(m-1);
  rhs = x.*[h(1)/2;(h(1:m-2)+h(2:m-1))/2;h(m-1)/2];
  rhs(1) = 0;
  rhs(m) = 0;
  u = M\rhs;
  err(counter) = norm(u-exact(x),Inf);
end
loglog(mrange,err,'*',mrange,err(1)*(mrange/mrange(1)).^(-2))
legend('errore','ordine 2')

% interpolante lineare a tratti
%
% c(j)*(x-x(j))+u(j) in [x(j),x(j+1)], j=1:m-1
%
% vale u(j) in x(j). Poi, impongo la continuita'
%
% c(j)*(x(j+1)-x(j))+u(j)=c(j+1)*(x(j+1)-x(j+1))+u(j+1)
%
% da cui
%
% c(j) = (u(j+1)-u(j))/h(j)
%
% quindi costruisco una struttura pp
P = [(u(2:m)-u(1:m-1))./h,u(1:m-1)];
pp = mkpp(x,P);
% che posso valutare dove voglio
xx = linspace(a,b,30);
uu = ppval(pp,xx);
figure
plot(xx,uu,'*',xx,exact(xx))